searchData={"items":[{"type":"module","title":"OpenApiCodeGen","doc":"Main module that coordinates the code generation.","ref":"OpenApiCodeGen.html"},{"type":"function","title":"OpenApiCodeGen.generate/3","doc":"","ref":"OpenApiCodeGen.html#generate/3"},{"type":"module","title":"OpenApiCodeGen.Ast","doc":"Contains functions to help with Ast operations.","ref":"OpenApiCodeGen.Ast.html"},{"type":"function","title":"OpenApiCodeGen.Ast.generate_path_interpolation/2","doc":"Generates an interpolated string given a URL path.","ref":"OpenApiCodeGen.Ast.html#generate_path_interpolation/2"},{"type":"function","title":"OpenApiCodeGen.Ast.sanitize_name/2","doc":"Converts a string or atom into a variable. It also checks for reserved words and appends `_param` to the variable name if it is a reserved word.","ref":"OpenApiCodeGen.Ast.html#sanitize_name/2"},{"type":"function","title":"OpenApiCodeGen.Ast.to_file!/3","doc":"Converts the AST into a string, formats it, styles it and writes it to a file and returns the path to the file.","ref":"OpenApiCodeGen.Ast.html#to_file!/3"},{"type":"function","title":"OpenApiCodeGen.Ast.to_var/2","doc":"Converts a string or atom into a variable.","ref":"OpenApiCodeGen.Ast.html#to_var/2"},{"type":"function","title":"Examples - OpenApiCodeGen.Ast.to_var/2","doc":"iex> to_var(:my_var, __MODULE__)\n    {:my_var, [], __MODULE__}\n\n    iex> to_var(\"my_var\", __MODULE__)\n    {:my_var, [], __MODULE__}\n\n    iex> to_var(\"myVar\", __MODULE__)\n    {:my_var, [], __MODULE__}","ref":"OpenApiCodeGen.Ast.html#to_var/2-examples"},{"type":"module","title":"OpenApiCodeGen.CLI","doc":"Usage: openapi_codegen [options] INPUT_FILE\n\nAvailable options:\n\n  --output-path    Output directory where the code should be generated.\n  --req            To use the :req as HTTP client.\n  --tesla          To use the :tesla as HTTP client (default).\n\nThe --help and --version options can be given instead of a command for usage and versioning information.","ref":"OpenApiCodeGen.CLI.html"},{"type":"function","title":"OpenApiCodeGen.CLI.main/1","doc":"","ref":"OpenApiCodeGen.CLI.html#main/1"},{"type":"function","title":"OpenApiCodeGen.CLI.usage/0","doc":"","ref":"OpenApiCodeGen.CLI.html#usage/0"},{"type":"module","title":"OpenApiCodeGen.Client.QueryParam","doc":"Generates query param AST from OpenAPI spec using the `parameters` key.","ref":"OpenApiCodeGen.Client.QueryParam.html"},{"type":"function","title":"OpenApiCodeGen.Client.QueryParam.generate/2","doc":"Generates query param AST from OpenAPI spec using the `parameters` key.\nReturns the variable and the keyword list elements to be used.","ref":"OpenApiCodeGen.Client.QueryParam.html#generate/2"},{"type":"module","title":"OpenApiCodeGen.Client.Req","doc":"Req client code generation.","ref":"OpenApiCodeGen.Client.Req.html"},{"type":"function","title":"OpenApiCodeGen.Client.Req.generate/2","doc":"Generates client AST from OpenAPI spec using:","ref":"OpenApiCodeGen.Client.Req.html#generate/2"},{"type":"function","title":"Params - OpenApiCodeGen.Client.Req.generate/2","doc":"* `servers` to generate Tesla middleware for the base URL\n  * `operationId` for the name of the functions\n  * `paths` keys to determine method for the function\n  * `requestBody` to generate the request body argument\n  * `path` to generate the request path with string interpolation\n  * `parameters` to generate the URL parameters (if they are of type `query`)","ref":"OpenApiCodeGen.Client.Req.html#generate/2-params"},{"type":"module","title":"OpenApiCodeGen.Client.Req.Path","doc":"Path generation operations for Req.","ref":"OpenApiCodeGen.Client.Req.Path.html"},{"type":"function","title":"OpenApiCodeGen.Client.Req.Path.generate/2","doc":"Generates an interpolated string to be used by the client.","ref":"OpenApiCodeGen.Client.Req.Path.html#generate/2"},{"type":"function","title":"Params - OpenApiCodeGen.Client.Req.Path.generate/2","doc":"* `client_module_name` module name of the generated client\n  * `path` to generate the request path with string interpolation","ref":"OpenApiCodeGen.Client.Req.Path.html#generate/2-params"},{"type":"module","title":"OpenApiCodeGen.Client.RequestBody","doc":"Generates request body AST from OpenAPI spec using the `requestBody` key.","ref":"OpenApiCodeGen.Client.RequestBody.html"},{"type":"function","title":"OpenApiCodeGen.Client.RequestBody.generate/2","doc":"Generates request body AST from OpenAPI spec using the `requestBody` key.\n\nThe rules for generation are as follows:\n* When the request body is of type `application/json` and has a `$ref` key, it will generate a variable with the name of the component and assign it to the variable.\n* When the request body is of type `application/json` and has items, it will generate a variable with the name of the component plurarized and assign it to the variable.\n* Otherwise, it will be a variable named `body` and will be assigned to the variable.","ref":"OpenApiCodeGen.Client.RequestBody.html#generate/2"},{"type":"module","title":"OpenApiCodeGen.Client.Tesla","doc":"Tesla client code generation.","ref":"OpenApiCodeGen.Client.Tesla.html"},{"type":"function","title":"OpenApiCodeGen.Client.Tesla.generate/2","doc":"Generates client AST from OpenAPI spec using:","ref":"OpenApiCodeGen.Client.Tesla.html#generate/2"},{"type":"function","title":"Params - OpenApiCodeGen.Client.Tesla.generate/2","doc":"* `servers` to generate Tesla middleware for the base URL\n  * `operationId` for the name of the functions\n  * `paths` keys to determine method for the function\n  * `requestBody` to generate the request body argument\n  * `path` to generate the request path with string interpolation\n  * `parameters` to generate the URL parameters (if they are of type `query`)","ref":"OpenApiCodeGen.Client.Tesla.html#generate/2-params"},{"type":"module","title":"OpenApiCodeGen.Client.Tesla.Path","doc":"Path generation operations for Tesla.","ref":"OpenApiCodeGen.Client.Tesla.Path.html"},{"type":"function","title":"OpenApiCodeGen.Client.Tesla.Path.generate/3","doc":"Uses Tesla.build_url with an interpolated string and a set of parameters to generate the URLs to be used by the client","ref":"OpenApiCodeGen.Client.Tesla.Path.html#generate/3"},{"type":"function","title":"Params - OpenApiCodeGen.Client.Tesla.Path.generate/3","doc":"* `client_module_name` module name of the generated client\n  * `path` to generate the request path with string interpolation\n  * `url_parameters` generated by `OpenApi.Codegen.Client.QueryParam` to generate the URL parameters","ref":"OpenApiCodeGen.Client.Tesla.Path.html#generate/3-params"},{"type":"module","title":"OpenApiCodeGen.Components","doc":"Generates components AST from OpenAPI spec using the `schemas` key.","ref":"OpenApiCodeGen.Components.html"},{"type":"function","title":"OpenApiCodeGen.Components.generate/2","doc":"Generates components AST from OpenAPI spec using the `schemas` key.\n\nReturns the name of the component and the AST for said component.","ref":"OpenApiCodeGen.Components.html#generate/2"},{"type":"extras","title":"Overview","doc":"# OpenAPI Code Generation\n\nCode generator that ingest a OpenAPI Specification and writes the structs that represent resources of that given specification and also builds the client based on the paths.\n\nCurrently supports two types of generation:\n\n* [Tesla](https://hexdocs.pm/tesla/readme.html) - Generates a module with a Tesla client.\n* [Req](https://hexdocs.pm/req/readme.html) - Generates a module using Req.\n\nBy default we're using Jason for encoding and decoding of structs\n\nDoes not require you to install extra dependencies as we're using","ref":"readme.html"},{"type":"extras","title":"Roadmap - Overview","doc":"- [x] Support YAML specification parsing\n- [ ] Support Inheritance and Polymorphism\n- [ ] Add typespecs to generated Structs\n- [ ] Add typespecs to Client\n- [ ] Generate tests for Client","ref":"readme.html#roadmap"},{"type":"extras","title":"Installation - Overview","doc":"Install it using:\n\n```sh\nmix do local.rebar --force, local.hex --force\nmix escript.install hex openapi_codegen\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Overview","doc":"Generating a Tesla client using PetStore example:\n\n`openapi_codegen --tesla --output-path lib openapi_petstore.json`\n\nGenerating a Req client using PetStore example:\n\n`openapi_codegen --req --output-path lib openapi_petstore.json`\n\nThis examples will generate your code in your folder `lib` and also create a `lib/components` with all the structs.\n\nLearn more on how to use it with `openapi_codegen --help`.","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}